/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaCorridaDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaCorrida;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.service.CategoriaCorridaService;
import com.rjconsultores.ventaboletos.service.LogAuditoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Administrador
 */
@Service("categoriaCorridaService")
public class CategoriaCorridaServiceImpl implements CategoriaCorridaService {

    @Autowired
    private CategoriaCorridaDAO categoriaCorridaDAO;
    @Autowired
    private LogAuditoriaService logAuditoriaService;


    public List<CategoriaCorrida> obtenerTodos() {
        return categoriaCorridaDAO.obtenerTodos();
    }

    public CategoriaCorrida obtenerID(Integer id) {
        return categoriaCorridaDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaCorrida suscribir(CategoriaCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaCorridaDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaCorrida actualizacion(CategoriaCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaCorridaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);
        categoriaCorridaDAO.actualizacion(entidad);
        logAuditoriaService.auditarExclusao(entidad, null);
    }

    public CategoriaCorrida busquedaPoCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaCorridaDAO.busquedaPoCategoriaCtrl(categoriaCtrl);
    }

}
